From 29bc17710310e97152e1a6ee8562aa6c667adb94 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: May 04 2020 08:40:45 +0000
Subject: [PATCH 535/2232] Merge pull request #186 from dtolnay/batch


Batch parse errors
---

diff --git a/gen/src/mod.rs b/gen/src/mod.rs
index c7b3c3c..6663e4b 100644
--- a/gen/src/mod.rs
+++ b/gen/src/mod.rs
@@ -8,6 +8,7 @@ mod write;
 
 use self::error::{format_err, Error, Result};
 use crate::syntax::namespace::Namespace;
+use crate::syntax::report::Errors;
 use crate::syntax::{self, check, Types};
 use quote::quote;
 use std::fs;
@@ -42,12 +43,15 @@ fn generate(path: &Path, opt: Opt, header: bool) -> Vec<u8> {
     };
     match (|| -> Result<_> {
         proc_macro2::fallback::force();
+        let ref mut errors = Errors::new();
         let syntax = syn::parse_file(&source)?;
         let bridge = find_bridge_mod(syntax)?;
         let ref namespace = bridge.namespace;
-        let ref apis = syntax::parse_items(bridge.module)?;
-        let ref types = Types::collect(apis)?;
-        check::typecheck(namespace, apis, types)?;
+        let ref apis = syntax::parse_items(errors, bridge.module);
+        let ref types = Types::collect(errors, apis);
+        errors.propagate()?;
+        check::typecheck(errors, namespace, apis, types);
+        errors.propagate()?;
         let out = write::gen(namespace, apis, types, opt, header);
         Ok(out)
     })() {
diff --git a/macro/src/expand.rs b/macro/src/expand.rs
index 737c389..e67902b 100644
--- a/macro/src/expand.rs
+++ b/macro/src/expand.rs
@@ -1,5 +1,6 @@
 use crate::syntax::atom::Atom::{self, *};
 use crate::syntax::namespace::Namespace;
+use crate::syntax::report::Errors;
 use crate::syntax::symbol::Symbol;
 use crate::syntax::{
     self, check, mangle, Api, Enum, ExternFn, ExternType, Signature, Struct, Type, Types,
@@ -8,16 +9,22 @@ use proc_macro2::{Ident, Span, TokenStream};
 use quote::{format_ident, quote, quote_spanned, ToTokens};
 use syn::{parse_quote, Error, ItemMod, Result, Token};
 
-pub fn bridge(namespace: &Namespace, ffi: ItemMod) -> Result<TokenStream> {
-    let ident = &ffi.ident;
-    let content = ffi.content.ok_or(Error::new(
+pub fn bridge(namespace: &Namespace, mut ffi: ItemMod) -> Result<TokenStream> {
+    let ref mut errors = Errors::new();
+    let content = ffi.content.take().ok_or(Error::new(
         Span::call_site(),
         "#[cxx::bridge] module must have inline contents",
     ))?;
-    let ref apis = syntax::parse_items(content.1)?;
-    let ref types = Types::collect(apis)?;
-    check::typecheck(namespace, apis, types)?;
+    let ref apis = syntax::parse_items(errors, content.1);
+    let ref types = Types::collect(errors, apis);
+    errors.propagate()?;
+    check::typecheck(errors, namespace, apis, types);
+    errors.propagate()?;
+
+    Ok(expand(namespace, ffi, apis, types))
+}
 
+fn expand(namespace: &Namespace, ffi: ItemMod, apis: &[Api], types: &Types) -> TokenStream {
     let mut expanded = TokenStream::new();
     let mut hidden = TokenStream::new();
 
@@ -93,15 +100,16 @@ pub fn bridge(namespace: &Namespace, ffi: ItemMod) -> Result<TokenStream> {
         .into_iter()
         .filter(|attr| attr.path.is_ident("doc"));
     let vis = &ffi.vis;
+    let ident = &ffi.ident;
 
-    Ok(quote! {
+    quote! {
         #(#attrs)*
         #[deny(improper_ctypes)]
         #[allow(non_snake_case)]
         #vis mod #ident {
             #expanded
         }
-    })
+    }
 }
 
 fn expand_struct(strct: &Struct) -> TokenStream {
diff --git a/syntax/check.rs b/syntax/check.rs
index 5d442ce..72b4a6c 100644
--- a/syntax/check.rs
+++ b/syntax/check.rs
@@ -1,5 +1,6 @@
 use crate::syntax::atom::Atom::{self, *};
 use crate::syntax::namespace::Namespace;
+use crate::syntax::report::Errors;
 use crate::syntax::{
     error, ident, Api, Enum, ExternFn, ExternType, Lang, Receiver, Ref, Slice, Struct, Ty1, Type,
     Types,
@@ -9,25 +10,21 @@ use quote::{quote, ToTokens};
 use std::collections::HashSet;
 use std::fmt::Display;
 use std::u32;
-use syn::{Error, Result};
 
 pub(crate) struct Check<'a> {
     namespace: &'a Namespace,
     apis: &'a [Api],
     types: &'a Types<'a>,
-    errors: &'a mut Vec<Error>,
+    errors: &'a mut Errors,
 }
 
-pub(crate) fn typecheck(namespace: &Namespace, apis: &[Api], types: &Types) -> Result<()> {
-    let mut errors = Vec::new();
-    let mut cx = Check {
+pub(crate) fn typecheck(cx: &mut Errors, namespace: &Namespace, apis: &[Api], types: &Types) {
+    do_typecheck(&mut Check {
         namespace,
         apis,
         types,
-        errors: &mut errors,
-    };
-    do_typecheck(&mut cx);
-    combine_errors(errors)
+        errors: cx,
+    });
 }
 
 fn do_typecheck(cx: &mut Check) {
@@ -59,7 +56,7 @@ fn do_typecheck(cx: &mut Check) {
 
 impl Check<'_> {
     pub(crate) fn error(&mut self, sp: impl ToTokens, msg: impl Display) {
-        self.errors.push(Error::new_spanned(sp, msg));
+        self.errors.error(sp, msg);
     }
 }
 
@@ -373,18 +370,6 @@ fn span_for_receiver_error(receiver: &Receiver) -> TokenStream {
     }
 }
 
-fn combine_errors(errors: Vec<Error>) -> Result<()> {
-    let mut iter = errors.into_iter();
-    let mut all_errors = match iter.next() {
-        Some(err) => err,
-        None => return Ok(()),
-    };
-    for err in iter {
-        all_errors.combine(err);
-    }
-    Err(all_errors)
-}
-
 fn describe(cx: &mut Check, ty: &Type) -> String {
     match ty {
         Type::Ident(ident) => {
diff --git a/syntax/mod.rs b/syntax/mod.rs
index 9b1a7e5..e6c5bb8 100644
--- a/syntax/mod.rs
+++ b/syntax/mod.rs
@@ -10,6 +10,7 @@ mod impls;
 pub mod mangle;
 pub mod namespace;
 mod parse;
+pub mod report;
 pub mod set;
 pub mod symbol;
 mod tokens;
diff --git a/syntax/parse.rs b/syntax/parse.rs
index a0dddbd..8bf0a4a 100644
--- a/syntax/parse.rs
+++ b/syntax/parse.rs
@@ -1,3 +1,4 @@
+use crate::syntax::report::Errors;
 use crate::syntax::Atom::*;
 use crate::syntax::{
     attrs, error, Api, Doc, Enum, ExternFn, ExternType, Lang, Receiver, Ref, Signature, Slice,
@@ -16,27 +17,24 @@ pub mod kw {
     syn::custom_keyword!(Result);
 }
 
-pub fn parse_items(items: Vec<Item>) -> Result<Vec<Api>> {
+pub fn parse_items(cx: &mut Errors, items: Vec<Item>) -> Vec<Api> {
     let mut apis = Vec::new();
     for item in items {
         match item {
-            Item::Struct(item) => {
-                let strct = parse_struct(item)?;
-                apis.push(strct);
-            }
-            Item::Enum(item) => {
-                let enm = parse_enum(item)?;
-                apis.push(enm);
-            }
-            Item::ForeignMod(foreign_mod) => {
-                let functions = parse_foreign_mod(foreign_mod)?;
-                apis.extend(functions);
-            }
-            Item::Use(item) => return Err(Error::new_spanned(item, error::USE_NOT_ALLOWED)),
-            _ => return Err(Error::new_spanned(item, "unsupported item")),
+            Item::Struct(item) => match parse_struct(item) {
+                Ok(strct) => apis.push(strct),
+                Err(err) => cx.push(err),
+            },
+            Item::Enum(item) => match parse_enum(item) {
+                Ok(enm) => apis.push(enm),
+                Err(err) => cx.push(err),
+            },
+            Item::ForeignMod(foreign_mod) => parse_foreign_mod(cx, foreign_mod, &mut apis),
+            Item::Use(item) => cx.error(item, error::USE_NOT_ALLOWED),
+            _ => cx.error(item, "unsupported item"),
         }
     }
-    Ok(apis)
+    apis
 }
 
 fn parse_struct(item: ItemStruct) -> Result<Api> {
@@ -151,8 +149,11 @@ fn parse_variant(variant: RustVariant) -> Result<Variant> {
     }
 }
 
-fn parse_foreign_mod(foreign_mod: ItemForeignMod) -> Result<Vec<Api>> {
-    let lang = parse_lang(foreign_mod.abi)?;
+fn parse_foreign_mod(cx: &mut Errors, foreign_mod: ItemForeignMod, out: &mut Vec<Api>) {
+    let lang = match parse_lang(foreign_mod.abi) {
+        Ok(lang) => lang,
+        Err(err) => return cx.push(err),
+    };
     let api_type = match lang {
         Lang::Cxx => Api::CxxType,
         Lang::Rust => Api::RustType,
@@ -165,19 +166,21 @@ fn parse_foreign_mod(foreign_mod: ItemForeignMod) -> Result<Vec<Api>> {
     let mut items = Vec::new();
     for foreign in &foreign_mod.items {
         match foreign {
-            ForeignItem::Type(foreign) => {
-                let ety = parse_extern_type(foreign)?;
-                items.push(api_type(ety));
-            }
-            ForeignItem::Fn(foreign) => {
-                let efn = parse_extern_fn(foreign, lang)?;
-                items.push(api_function(efn));
-            }
+            ForeignItem::Type(foreign) => match parse_extern_type(foreign) {
+                Ok(ety) => items.push(api_type(ety)),
+                Err(err) => cx.push(err),
+            },
+            ForeignItem::Fn(foreign) => match parse_extern_fn(foreign, lang) {
+                Ok(efn) => items.push(api_function(efn)),
+                Err(err) => cx.push(err),
+            },
             ForeignItem::Macro(foreign) if foreign.mac.path.is_ident("include") => {
-                let include = foreign.mac.parse_body()?;
-                items.push(Api::Include(include));
+                match foreign.mac.parse_body() {
+                    Ok(include) => items.push(Api::Include(include)),
+                    Err(err) => cx.push(err),
+                }
             }
-            _ => return Err(Error::new_spanned(foreign, "unsupported foreign item")),
+            _ => cx.error(foreign, "unsupported foreign item"),
         }
     }
 
@@ -198,7 +201,7 @@ fn parse_foreign_mod(foreign_mod: ItemForeignMod) -> Result<Vec<Api>> {
         }
     }
 
-    Ok(items)
+    out.extend(items);
 }
 
 fn parse_lang(abi: Abi) -> Result<Lang> {
diff --git a/syntax/report.rs b/syntax/report.rs
new file mode 100644
index 0000000..d1d8bc9
--- /dev/null
+++ b/syntax/report.rs
@@ -0,0 +1,33 @@
+use quote::ToTokens;
+use std::fmt::Display;
+use syn::{Error, Result};
+
+pub struct Errors {
+    errors: Vec<Error>,
+}
+
+impl Errors {
+    pub fn new() -> Self {
+        Errors { errors: Vec::new() }
+    }
+
+    pub fn error(&mut self, sp: impl ToTokens, msg: impl Display) {
+        self.errors.push(Error::new_spanned(sp, msg));
+    }
+
+    pub fn push(&mut self, error: Error) {
+        self.errors.push(error);
+    }
+
+    pub fn propagate(&mut self) -> Result<()> {
+        let mut iter = self.errors.drain(..);
+        let mut all_errors = match iter.next() {
+            Some(err) => err,
+            None => return Ok(()),
+        };
+        for err in iter {
+            all_errors.combine(err);
+        }
+        Err(all_errors)
+    }
+}
diff --git a/syntax/types.rs b/syntax/types.rs
index 4842507..02249e2 100644
--- a/syntax/types.rs
+++ b/syntax/types.rs
@@ -1,10 +1,10 @@
 use crate::syntax::atom::Atom::{self, *};
+use crate::syntax::report::Errors;
 use crate::syntax::set::OrderedSet as Set;
 use crate::syntax::{Api, Derive, Enum, Struct, Type};
 use proc_macro2::Ident;
 use quote::ToTokens;
 use std::collections::{BTreeMap as Map, HashSet as UnorderedSet};
-use syn::{Error, Result};
 
 pub struct Types<'a> {
     pub all: Set<'a, Type>,
@@ -15,7 +15,7 @@ pub struct Types<'a> {
 }
 
 impl<'a> Types<'a> {
-    pub fn collect(apis: &'a [Api]) -> Result<Self> {
+    pub fn collect(cx: &mut Errors, apis: &'a [Api]) -> Self {
         let mut all = Set::new();
         let mut structs = Map::new();
         let mut enums = Map::new();
@@ -50,39 +50,41 @@ impl<'a> Types<'a> {
                 Api::Include(_) => {}
                 Api::Struct(strct) => {
                     let ident = &strct.ident;
-                    if !type_names.insert(ident) {
-                        return Err(duplicate_name(strct, ident));
+                    if type_names.insert(ident) {
+                        structs.insert(ident.clone(), strct);
+                    } else {
+                        duplicate_name(cx, strct, ident);
                     }
-                    structs.insert(ident.clone(), strct);
                     for field in &strct.fields {
                         visit(&mut all, &field.ty);
                     }
                 }
                 Api::Enum(enm) => {
                     let ident = &enm.ident;
-                    if !type_names.insert(ident) {
-                        return Err(duplicate_name(enm, ident));
+                    if type_names.insert(ident) {
+                        enums.insert(ident.clone(), enm);
+                    } else {
+                        duplicate_name(cx, enm, ident);
                     }
-                    enums.insert(ident.clone(), enm);
                 }
                 Api::CxxType(ety) => {
                     let ident = &ety.ident;
                     if !type_names.insert(ident) {
-                        return Err(duplicate_name(ety, ident));
+                        duplicate_name(cx, ety, ident);
                     }
                     cxx.insert(ident);
                 }
                 Api::RustType(ety) => {
                     let ident = &ety.ident;
                     if !type_names.insert(ident) {
-                        return Err(duplicate_name(ety, ident));
+                        duplicate_name(cx, ety, ident);
                     }
                     rust.insert(ident);
                 }
                 Api::CxxFunction(efn) | Api::RustFunction(efn) => {
                     let ident = &efn.ident;
                     if !function_names.insert((&efn.receiver, ident)) {
-                        return Err(duplicate_name(efn, ident));
+                        duplicate_name(cx, efn, ident);
                     }
                     for arg in &efn.args {
                         visit(&mut all, &arg.ty);
@@ -94,13 +96,13 @@ impl<'a> Types<'a> {
             }
         }
 
-        Ok(Types {
+        Types {
             all,
             structs,
             enums,
             cxx,
             rust,
-        })
+        }
     }
 
     pub fn needs_indirect_abi(&self, ty: &Type) -> bool {
@@ -135,7 +137,7 @@ impl<'t, 'a> IntoIterator for &'t Types<'a> {
     }
 }
 
-fn duplicate_name(sp: impl ToTokens, ident: &Ident) -> Error {
+fn duplicate_name(cx: &mut Errors, sp: impl ToTokens, ident: &Ident) {
     let msg = format!("the name `{}` is defined multiple times", ident);
-    Error::new_spanned(sp, msg)
+    cx.error(sp, msg);
 }
diff --git a/tests/ui/multiple_parse_error.rs b/tests/ui/multiple_parse_error.rs
new file mode 100644
index 0000000..061eab6
--- /dev/null
+++ b/tests/ui/multiple_parse_error.rs
@@ -0,0 +1,9 @@
+#[cxx::bridge]
+mod ffi {
+    struct Monad<T>;
+
+    extern "Haskell" {
+    }
+}
+
+fn main() {}
diff --git a/tests/ui/multiple_parse_error.stderr b/tests/ui/multiple_parse_error.stderr
new file mode 100644
index 0000000..854aa90
--- /dev/null
+++ b/tests/ui/multiple_parse_error.stderr
@@ -0,0 +1,11 @@
+error: struct with generic parameters is not supported yet
+ --> $DIR/multiple_parse_error.rs:3:5
+  |
+3 |     struct Monad<T>;
+  |     ^^^^^^^^^^^^^^^
+
+error: unrecognized ABI
+ --> $DIR/multiple_parse_error.rs:5:5
+  |
+5 |     extern "Haskell" {
+  |     ^^^^^^^^^^^^^^^^

